#!/usr/bin/perl -T
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2011              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use RFC::Main;
use RFC::Rig;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use CGI qw(:standard :netscape);

my $r = param('rig');
unless ($r)
{
    print header();
    print "No rig specified!\n";
    exit;
}
my $rig = RFC::Rig->new($r);
my @d = $rig->list_devices_control('PID');
my @devs = ();
my $data = undef;
foreach my $name (@d)
{
    my $dev = $rig->get_device('PID',$name);
    ### exclude readonly devices and non engaged gasses as well as implicitly initialised devices ###
    next if ($dev->readonly);
    next if ($dev->readstring_ignore());
    push @devs,$name;
}

if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end;
}
else
{
    #### husk at aendre accessparameter til det relevante for scriptet!! ####
    if (&login_ok())
    {
        &print_header("Set PID setpount for rig ".$rig->name);
        if ($ENV{'HTTP_USER_AGENT'} =~ /MSIE/)
        {
	    print RFC_start_html(-title=>"Set PID regulator setpoint for rig ".$rig->name, -style=>{src=>'/celltest/RFCcontrol.css'},-onBlur=>'initiateSelfClosing()');
        }
        else
        {
	    print RFC_start_html(-title=>"Set PID regulator setpoint for rig ".$rig->name, -style=>{src=>'/celltest/RFCcontrol.css'},-onBlur=>'self.close()');
	}
	print '<center>';
	print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr height=1>';
	print '<td width="5%"></td>';
	print '<td width="20%"></td>';
	print '<td width="35%"></td>';
	print '<td width="15%"></td>';
	print '<td width="20%"></td>';
	print '<td width="5%"></td>';
	print '</tr>';
	print start_form(-name=>'sofc');
	print '<tr><td colspan=6 class=heading> Set PID setpoint for rig ',$rig->name,'</td></tr>';
	print '<tr><td></td><th>';
	my ($t,$r,$j) = ('','','');
	if (@devs > 1)
	{
	    print 'Select PID </th><th>';
	    print popup_menu(-name=>'device',-values=>['',sort @devs],-default=>'',-class=>'textfield',-force=>'1',-onchange=>'set_default()');
	    $j = "    var element = document.sofc.device;\n";
	    $j .= "    opener.document.pid.device.value = element[element.selectedIndex].value;\n";
	}
	else
	{
	    my $d = $rig->get_device('PID',$devs[0]);
	    $t = $d->read();
	    $j = "    opener.document.pid.device.value = document.sofc.device.value;\n";
	    print hidden(-name=>'device',-value=>$devs[0],-force=>1);
	}
	print '</th><td colspan=1>';
	print '</td><td rowspan=3>';
	print button(-name=>'test',-value=>'Ok',-class=>'s3',-OnClick=>'set_relay()');
	print '</td></tr>',"\n";
	print '<tr><td></td><th> Setpoint: </th><td>';
        print textfield(-name=>'flow',-value=>$t,-force=>'1',-class=>'textfield');
	print '</td><th></th></tr>',"\n";
	print end_form;
	print <<END;

<script language=javascript>

function set_default()
{
    var element = document.sofc.device;
    var id = element.selectedIndex;
    var name = element[id].value;
    document.sofc.flow.disabled = true;	
    run_ajax('rig_ajax_run.cgi','&action=run_device_function&type=PID&dname='+name+'&function=read',set_default_ajax);
}

function set_default_ajax(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK")
    {
	document.sofc.flow.value = arr[1];	
	document.sofc.flow.disabled = false;	
    }
    else
    {
	alert(res);
    }
}


function set_relay()
{
$j    
    opener.document.pid.setpoint.value = document.sofc.flow.value;
    opener.set_pid_go();
    self.close();
}

</script>

END

        print end_html;
    }
    else
    {
        &not_auth;
    }
}

